import { ReactNode } from "react";
import { NextApiHandler, NextApiRequest } from "next";
type DataField = {
    property: string;
    name: string;
};
type DataValue = DataField & {
    type: 'count';
};
export function Matrix({ columns, rows, values, appearance }: Partial<{
    columns: DataField;
    rows: DataField;
    appearance: Partial<{
        placeholder: () => ReactNode;
        classNames: Partial<{
            table: string;
            header: string;
            body: string;
            row: (index: number) => string;
            columnHeader: (index: number, column: DataField) => string;
            rowHeader: (index: number, row: DataField) => string;
            cell: (value: DataValue) => string;
        }>;
    }>;
}> & {
    values: DataValue;
}): JSX.Element;
type _DataField1 = {
    property: string;
    name: string;
};
type DataValueFunctions<T> = {
    [key in keyof T]: () => _DataField1 & {
        type: key;
    };
};
type _DataValue1 = _DataField1 & DataValueFunctions<{
    count: true;
}>;
type Table<T> = {
    [column in keyof T]: _DataValue1;
} & {
    handler: (source: (req: NextApiRequest) => Promise<T[]>) => NextApiHandler;
};
export function defineTable<T, U extends string>({ name, columns, }: {
    name: U;
    columns: Array<keyof T>;
}): Table<T>;
